### Configuration

# set --build-args SKIP_TESTS=true to use
ARG SKIP_TESTS



# --- build-env
FROM docker.io/gradle:7.6-jdk as build-env
ARG MAVEN_USERNAME
ARG MAVEN_PASSWORD
ENV MAVEN_USERNAME=$MAVEN_USERNAME
ENV MAVEN_USERNAME=$MAVEN_PASSWORD
WORKDIR /appbuild

COPY . /appbuild

# cache Gradle dependencies
VOLUME /home/gradle/.gradle
RUN echo "MAVEN Username is : ${MAVEN_USERNAME} $MAVEN_USERNAME"

RUN if [ -z "$SKIP_TESTS" ]; \
    then echo "* Running full build" && gradle -i clean build installDist -x test; \
    else echo "* Building but skipping tests" && gradle -i clean installDist -x test; \
    fi

# --- opa-env
FROM docker.io/openpolicyagent/opa:0.46.1-static as opa-env

# --- iota-env
FROM docker.io/waltid/waltid_iota_identity_wrapper:latest as iota-env

# --- app-env
FROM docker.io/eclipse-temurin:19 AS app-env

WORKDIR /app

COPY --from=opa-env /opa /usr/local/bin/opa
COPY --from=iota-env /usr/local/lib/libwaltid_iota_identity_wrapper.so /usr/local/lib/libwaltid_iota_identity_wrapper.so
RUN ldconfig


COPY --from=build-env /appbuild/build/install/waltid-idpkit /app/
COPY --from=build-env /appbuild/service-matrix.properties /app/
COPY --from=build-env /appbuild/config /app/config


WORKDIR /app
ENV WALTID_WALLET_BACKEND_BIND_ADDRESS=0.0.0.0
ENTRYPOINT ["/app/bin/waltid-idpkit"]
